/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 */

#ifndef INITNG_PLUGIN
#define INITNG_PLUGIN
#include <stdarg.h>
#include "initng_system_states.h"
#include "initng_list.h"


typedef struct ft_module_h f_module_h;
struct ft_module_h
{
    void (*call_module) (f_module_h * module);
    int fds;
};

typedef union
{
    /* a skeleton, newer use */
    void *pointer;

    /* put all hook functions here */
    int (*test_status) (active_db_h * service, a_state_h * status);
    int (*status_change) (active_db_h * service);
    service_cache_h *(*parser) (const char *name);
    void (*swatcher) (h_sys_state state);
    int (*pipewatcher) (active_db_h * service, process_h * process,
                        char *buffer_pos);
    int (*launch) (active_db_h * service, process_h * process);
    int (*af_launcher) (active_db_h * service, process_h * process);
    int (*handle_killed) (active_db_h * service, process_h * process);
    void (*main) (void);
    void (*compensate_time) (int seconds);
    int (*err) (e_mt mt, const char *file, const char *func, int line,
                const char *format, va_list ap);
    int (*dep_on_check) (active_db_h * service, active_db_h * check);
    void (*alarm) (void);
    void (*hup) (void);
    f_module_h *fdh;
    int (*additional_parse) (service_cache_h * service);
    int (*dump_state) (void);
    int (*reload_state) (void);
    int (*start_dep_met) (active_db_h * service);
    int (*stop_dep_met) (active_db_h * service);
    int (*up_met) (active_db_h * service);

} uc __attribute__ ((__transparent_union__));


typedef struct s_callers_s s_call;
struct s_callers_s
{
    char *from_file;
    uc c;
    int order;
    struct list_head list;
};

#define while_list(current, call) list_for_each_entry_prev(current, &(call)->list, list)
#define while_list_safe(current, call, safe) list_for_each_entry_prev_safe(current, safe, &(call)->list, list)


#endif
